//+------------------------------------------------------------------+
//|                                      WeeklyOpenHistogram 1x0.mq4 |
//|                      Copyright  2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|  Created for NB 10.2 by fmuir April, 2012                        |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  DarkBlue
#property  indicator_color2  OrangeRed
#property  indicator_color3  Yellow

//---- indicator parameters
extern int barsToProcess = 1000;
int        j;
bool       Trigger = true;

//---- indicator buffers
double UpBuffer[];
double DownBuffer[];
double ZeroBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //---- Indicators
    j=0;
    Trigger=true;

    //---- 2 additional buffers are used for counting.
    IndicatorBuffers(3);
    //---- drawing settings
    SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4);
    SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4);
    SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,2);

    IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);

    //---- 3 indicator buffers mapping
    if(!SetIndexBuffer(0,UpBuffer) &&
       !SetIndexBuffer(1,DownBuffer) &&
       !SetIndexBuffer(2,ZeroBuffer))
       Print("cannot set indicator buffers!");
    //---- name for DataWindow and indicator subwindow label
    IndicatorShortName("WeeklyClose 1x1");
    //---- initialization done
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
    //----
   
    //----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    //----
    double wo, ma;
    int nLimit, i;
    int nCountedBars;
         
    nCountedBars = IndicatorCounted();
     //---- check for possible errors
    if(nCountedBars<0) return(-1);
    //---- last counted bar will be recounted
    if(nCountedBars>0) nCountedBars--;
    nLimit = Bars-nCountedBars;
    if(nLimit>barsToProcess) nLimit=barsToProcess;
    //---- main loop
    for(i=0; i<nLimit; i++)
      {
        DownBuffer[i] = 0.0;
        UpBuffer[i]   = 0.0;
        ZeroBuffer[i] = 0.0;
      
        if(TimeDayOfWeek(iTime(NULL,0,i))==0)
          {
            if(Trigger==true)
              {
                Trigger=false;  // Trigger fired
                j++;
              }
          }
        if(i==0 || i==1) j=0;

        if(TimeDayOfWeek(iTime(NULL,0,i))!= 0) Trigger=true;  // Trigger reset

        wo = iMA(NULL,PERIOD_W1,1,1,MODE_SMA,PRICE_CLOSE,j);
        ma = iMA(NULL,0,1,0,MODE_SMA,PRICE_MEDIAN,i);

        if(ma > wo)
           UpBuffer[i]   = NormalizeDouble(ma-wo,Digits);
        if(wo > ma)
           DownBuffer[i] = NormalizeDouble(ma-wo,Digits);
      }
    //----
    return(0);
  }

//+------------------------------------------------------------------+